﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConverterSlow
{
    public class ContractedEmployer : NotificationObject
    {
        public ContractedEmployer()
        { }

        public ContractedEmployer(int? employerID, string stateAbbreviation, string employer)
        {
            EmployerID = employerID;
            StateAbbreviation = stateAbbreviation;
            Employer = employer;
        }

        private int? _employerID;
        public int? EmployerID
        {
            get { return _employerID; }
            set
            {
                if (_employerID != value)
                {
                    _employerID = value;
                    FirePropertyChanged(() => EmployerID);
                }
            }
        }

        private string _stateAbbreviation;
        public string StateAbbreviation
        {
            get { return _stateAbbreviation; }
            set
            {
                if (_stateAbbreviation != value)
                {
                    _stateAbbreviation = value;
                    FirePropertyChanged(() => StateAbbreviation);
                }
            }

        }

        private string _employer;
        public string Employer
        {
            get { return _employer; }
            set
            {
                if (_employer != value)
                {
                    _employer = value;
                    FirePropertyChanged(() => Employer);
                }
            }
        }

        /// <summary>
        /// Overrides the Equals function so that Frequency objects don't have to be the exact same instance to be equal
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public override bool Equals(object obj)
        {
            if (obj == null || !(obj is ContractedEmployer))
                return false;
            return ((ContractedEmployer)obj).EmployerID == this.EmployerID;
        }

        //public static bool operator ==(ContractedEmployer a, ContractedEmployer b)
        //{
        //    // If both are null, or both are same instance, return true.
        //    if (System.Object.ReferenceEquals(a, b))
        //    {
        //        return true;
        //    }

        //    // If one is null, but not both, return false.
        //    if (((object)a == null) || ((object)b == null))
        //    {
        //        return false;
        //    }

        //    // Return true if the fields match:
        //    return a.EmployerID == b.EmployerID;
        //}

        //public static bool operator !=(ContractedEmployer a, ContractedEmployer b)
        //{
        //    return !(a == b);
        //}

        /// <summary>
        /// Included to not violate equals objects must have same hash code
        /// </summary>
        /// <returns></returns>
        public override int GetHashCode()
        {
            return this.EmployerID.GetHashCode();
        }
    }
}