﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Data;

namespace ConverterSlow.Converters
{
    public class StateEmployerConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            using (new WaitCursor())  //removing this WaitCursor is okay for scrolling, but then sorting/grouping freezes the grid without showing the user anything is happening
            {
                ObservableCollection<ContractedEmployer> collection = new ObservableCollection<ContractedEmployer>();

                if (value != null && value is string)
                {
                    string state = value.ToString();

                    if (GlobalContractedEmployerInfo.VendorID != null )
                    {
                        if (state == "FL")
                        {
                            //collection = ContractedEmployersForVendorData.Instance.GetContractedDistricts(GlobalContractedEmployerInfo.BillingDate, GlobalContractedEmployerInfo.VendorID, state, false);
                            collection = SampleData.floridaCollection;
                            Thread.Sleep(100);
                        }
                        else if (state == "MI")
                        {
                            collection = SampleData.michiganCollection;
                            Thread.Sleep(100);
                        }
                        else
                        {
                            //collection = ContractedEmployersForVendorData.Instance.GetContractedDistricts(GlobalContractedEmployerInfo.BillingDate, GlobalContractedEmployerInfo.VendorID, null, false);
                            collection = SampleData.completeCollection;
                            Thread.Sleep(100);
                        }
                    }
                }
                else  //this gets ALL possible combinations for the GroupBy or Export To Excel to work (instead of just showing the type)
                {
                    //collection = ContractedEmployersForVendorData.Instance.GetContractedDistricts(GlobalContractedEmployerInfo.BillingDate, GlobalContractedEmployerInfo.VendorID, null, false);
                    collection = SampleData.completeCollection;
                }

                return collection;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}