﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConverterSlow
{
    public class TiaaPlanBillingType : NotificationObject
    {
        public TiaaPlanBillingType()
        { }

        public TiaaPlanBillingType(int? tiaaPlanBillingTypeID, string tiaaPlanBillingType)
        {
            TiaaPlanBillingTypeID = tiaaPlanBillingTypeID;
            TiaaPlanBillingTypeDescription = tiaaPlanBillingType;
        }

        private int? _tiaaPlanBillingTypeID;
        public int? TiaaPlanBillingTypeID
        {
            get { return _tiaaPlanBillingTypeID; }
            set
            {
                if (_tiaaPlanBillingTypeID != value)
                {
                    _tiaaPlanBillingTypeID = value;
                    FirePropertyChanged(() => TiaaPlanBillingTypeID);
                }
            }
        }

        private string _tiaaPlanBillingTypeDescription;
        public string TiaaPlanBillingTypeDescription
        {
            get { return _tiaaPlanBillingTypeDescription; }
            set
            {
                if (_tiaaPlanBillingTypeDescription != value)
                {
                    _tiaaPlanBillingTypeDescription = value;
                    FirePropertyChanged(() => TiaaPlanBillingTypeDescription);
                }
            }

        }

        /// <summary>
        /// Overrides the Equals function so that Frequency objects don't have to be the exact same instance to be equal
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public override bool Equals(object obj)
        {
            if (obj == null || !(obj is TiaaPlanBillingType))
                return false;
            return ((TiaaPlanBillingType)obj).TiaaPlanBillingTypeID == this.TiaaPlanBillingTypeID;
        }

        public static bool operator ==(TiaaPlanBillingType a, TiaaPlanBillingType b)
        {
            // If both are null, or both are same instance, return true.
            if (System.Object.ReferenceEquals(a, b))
            {
                return true;
            }

            // If one is null, but not both, return false.
            if (((object)a == null) || ((object)b == null))
            {
                return false;
            }

            // Return true if the fields match:
            return a.TiaaPlanBillingTypeID == b.TiaaPlanBillingTypeID;
        }

        public static bool operator !=(TiaaPlanBillingType a, TiaaPlanBillingType b)
        {
            return !(a == b);
        }

        /// <summary>
        /// Included to not violate equals objects must have same hash code
        /// </summary>
        /// <returns></returns>
        public override int GetHashCode()
        {
            return this.TiaaPlanBillingTypeID.GetHashCode();
        }
    }
}