﻿using System;
using System.Windows.Input;

namespace ConverterSlow
{
    public class WaitCursor : IDisposable
    {
        //to use this class, use the following example syntax:
        //using (new WaitCursor())
        //{
        //long running task
        //}
        //this will automatically dispose of the hourglass when the task is completed
        private Cursor _previousCursor;

        public WaitCursor()
        {
            _previousCursor = Mouse.OverrideCursor;

            Mouse.OverrideCursor = Cursors.Wait;
        }

        #region IDisposable Members

        public void Dispose()
        {
            Mouse.OverrideCursor = _previousCursor;
        }

        #endregion
    }
}
